#
# S function to take class and logOR regression model matrix
# and create the Z design matrix and ZID vector
#
class2z<-function( cvec, id, k, dmat ){
        len_length
	if( max(cvec)!= k ){
		print(paste("k = ",k," is not equal to the cvec max."))
		print(paste("cvec max = ",max(cvec)))
		stop("exit class2z()") }
	if( min(cvec)!= 1 ){
		print(paste("cvec min = ",min(cvec),", must be 1."))
		stop("exit class2z()") }
	if( len(cvec) != len(id) ){
		print("cvec and id are unequal length.")
		stop("exit class2z()") }
	if( nrow(dmat) != k*(k+1)/2 ){
		print("dmat must have k*(k+1)/2 rows.")
		stop("exit class2z()") }
#
	x_table(id)
	nclust_len(x)
	n_len(cvec)

	total_0
	x_table(table(id))
	y_as.integer(names(x))
	for(i in 1:len(x)){
		if( y[i]>1 ){
			total_total + x[i]*(y[i]*(y[i]-1)/2)
		}else{
			total_total + x[i]
		}
	}

	z_matrix(0,total,ncol(dmat))
	zid_matrix(0,total,1)
	flag_0

	out<-.C("class2z",
		class=as.double(cvec),
		id=as.double(id),
		dmat,
		z=z,
		zid=as.double(zid),
		k=as.integer(k),
		n=as.integer(n),
		nrz=as.integer(total),
		p=as.integer(nrow(dmat)),
		q=as.integer(ncol(dmat)),
		nclust=as.integer(nclust),
		flag=as.integer(flag)) 

	dmat.names_rep("",k*(k+1)/2)
	count_0	
	for(i in 1:k){
	        for(j in i:k){
	                count_count+1
	                dmat.names[count]_paste("(",i,",",j,")",sep="")
	                }
	        }
	dimnames(dmat)_list(dmat.names,paste("a",c(1:ncol(dmat)),sep=""))

	x_list(z=out$z,zid=out$zid,model=dmat,flag=out$flag)
	x
}
