ord.EE.print _ function(x, bnames = NULL, anames = NULL)
{
	bet <- x[["beta"]]
	alp <- x[["alpha"]]
	len <- length
	p <- len(bet)
	q <- len(alp)
	bnames _ names(bet)
	anames _ names(alp)
	robvar <- x[["robcov"]]
	sebet <- sqrt(diag(robvar[1:p, 1:p, drop = F]))
	sealp <- sqrt(diag(robvar[(p + 1):(p + q), (p + 1):(p + q), drop = F]))
	cat("     \n")
	if( is.na(match("method",names(x))) ){
		cat("ALR results\n")
	}else{
		cat(paste("Results for method =",x$method,"\n"))
	}
	if( !is.na(match("b.weight",names(x))) ){
		cat(paste("       beta weight =",x$b.weight,"\n"))
	}
	if( !is.na(match("a.weight",names(x))) ){
		cat(paste("      alpha weight =",x$a.weight,"\n"))
	}
	cat("     \n")
	cat("Beta estimates and standard errors:\n")
	if( is.na(match("modcovbeta",names(x))) ){
		bmat <- cbind(bet, sebet, bet/sebet)
		dimnames(bmat) <- list(bnames, c("Est", "rob. s.e.", "rob. z"))
		print(bmat)
	}else{
		semod_sqrt(diag(x$modcovbeta))
		bmat <- cbind(bet, sebet, semod, bet/sebet)
		dimnames(bmat) <- list(bnames, c("Est", "rob. s.e.", 
				"mod. s.e.","rob. z"))
		print(bmat)
	}
	cat("     \n")
	cat("Alpha estimates and standard errors:\n")
	amat <- cbind(alp, sealp, alp/sealp)
	dimnames(amat) <- list(anames, c("Est", "rob. s.e.", "rob. z"))
	print(amat)
	cat("     \n")
	invisible(0)
}
